﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace eSlide
{
    public partial class Form1 : Form
    {
        int px, py;
        bool isDragging = false;

        public Form1()
        {
            InitializeComponent();
        }

        // 請注意，以下的 MouseEventArgs e 參數傳回的都是相對於被點選元件 richTextBox 的座標

        private void richTextBox_MouseDown(object sender, MouseEventArgs e)
        {
            px = e.X; // 記住滑鼠點下時相對於元件的 (x,y) 坐標。
            py = e.Y;
            isDragging = true;
        }

        private void richTextBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                // (e.X-px, e.Y-py) 儲存了滑鼠目前相對於點下時 的移動差距 (dx, dy)
                // 範例：
                // 如果差距為 (3,2)，則我們應該將元件向右下移動 (3,2) 的距離
                // 以便讓滑鼠相對於元件的位置永遠不變。
                richTextBox.Left += (e.X - px); 
                richTextBox.Top += (e.Y - py);
                
                labelMsg.Text = "e:("+e.X+","+e.Y+") p:("+px+","+py+") "
                     + "r=("+richTextBox.Left+","+richTextBox.Top+")";
                Console.WriteLine(labelMsg.Text);
            }
        }

        private void richTextBox_MouseUp(object sender, MouseEventArgs e)
        {
            isDragging = false;
        }
    }
}
